diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_away.c ircd-hybrid-6.0/src/m_away.c
--- ircd-hybrid-6.0.orig/src/m_away.c	Fri Jul 30 07:40:13 1999
+++ ircd-hybrid-6.0/src/m_away.c	Wed May 30 11:58:23 2001
@@ -124,6 +124,15 @@
 
   if (parc < 2 || !*awy2)
     {
+/* some lamers scripts continually do a /away, hence making a lot of
+   unnecessary traffic. *sigh* so... as comstud has done, I've
+   commented out this sendto_serv_butone() call -Dianora */
+      /* now we can send this .. as long as they were away before
+	 away messages can get out of sync, but it's much less load
+	 on the network -is */
+      /* Let's test this *before* we set sptr->user->away to NULL -- asuffield */
+      if (sptr->user->away)
+        sendto_serv_butone(cptr, ":%s AWAY", parv[0]); 
       /* Marking as not away */
       
       if (away)
@@ -131,10 +140,6 @@
           MyFree(away);
           sptr->user->away = NULL;
         }
-/* some lamers scripts continually do a /away, hence making a lot of
-   unnecessary traffic. *sigh* so... as comstud has done, I've
-   commented out this sendto_serv_butone() call -Dianora */
-/*      sendto_serv_butone(cptr, ":%s AWAY", parv[0]); */
       if (MyConnect(sptr))
         sendto_one(sptr, form_str(RPL_UNAWAY),
                    me.name, parv[0]);
@@ -148,7 +153,9 @@
 /* some lamers scripts continually do a /away, hence making a lot of
    unnecessary traffic. *sigh* so... as comstud has done, I've
    commented out this sendto_serv_butone() call -Dianora */
-/*  sendto_serv_butone(cptr, ":%s AWAY :%s", parv[0], awy2); */
+  /* see my comment above -is */
+  if (!sptr->user->away || strcmp(sptr->user->away, awy2)) /* So why not propogate only when it's changed? -- asuffield */
+    sendto_serv_butone(cptr, ":%s AWAY :%s", parv[0], awy2); 
 
   /* don't use realloc() -Dianora */
 
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/s_serv.c ircd-hybrid-6.0/src/s_serv.c
--- ircd-hybrid-6.0.orig/src/s_serv.c	Wed May 30 11:59:08 2001
+++ ircd-hybrid-6.0/src/s_serv.c	Wed May 30 11:59:01 2001
@@ -485,6 +485,9 @@
                  acptr->hopcount + 1, acptr->tsinfo, ubuf,
                  acptr->username, acptr->host,
                  acptr->user->server, acptr->info);
+      /* Let's propogate AWAY status in the burst as well */
+      if (acptr->user->away)
+	sendto_one(cptr, ":%s AWAY :%s", acptr->name, acptr->user->away);
     }
 }
 
